"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateV116 = exports.updateV100 = void 0;
const schematics_1 = require("@angular-devkit/schematics");
const schematics_2 = require("@o3r/schematics");
const stylistic_1 = require("./v10.0/stylistic");
const update_configs_1 = require("./v11.6/update-configs/update-configs");
/**
 * Update of Otter library V10.0
 */
function updateV100fn() {
    return (tree, context) => {
        const updateRules = [
            stylistic_1.addStylistic
        ];
        return (0, schematics_1.chain)(updateRules)(tree, context);
    };
}
/**
 * Update of Otter library V11.6
 */
function updateV116Fn() {
    return (tree, context) => {
        const updateRules = [
            (0, update_configs_1.updateEslintRecommended)()
        ];
        return (0, schematics_1.chain)(updateRules)(tree, context);
    };
}
/**
 * Update of Otter library V10.0
 */
exports.updateV100 = (0, schematics_2.createOtterSchematic)(updateV100fn);
/**
 * Update of Otter library V11.6
 */
exports.updateV116 = (0, schematics_2.createOtterSchematic)(updateV116Fn);
//# sourceMappingURL=index.js.map