"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addStylistic = void 0;
const node_fs_1 = require("node:fs");
const node_path_1 = require("node:path");
const schematics_1 = require("@o3r/schematics");
const dependencies_1 = require("@schematics/angular/utility/dependencies");
/**
 * Add Stylistic package in the dependencies
 */
const addStylistic = () => {
    const packageName = '@stylistic/eslint-plugin-ts';
    const packageJson = JSON.parse((0, node_fs_1.readFileSync)((0, node_path_1.resolve)(__dirname, '..', '..', '..', 'package.json'), { encoding: 'utf8' }));
    return (0, schematics_1.setupDependencies)({
        dependencies: {
            [packageName]: {
                inManifest: [{
                        range: packageJson.peerDependencies[packageName],
                        types: [dependencies_1.NodeDependencyType.Dev]
                    }]
            }
        }
    });
};
exports.addStylistic = addStylistic;
//# sourceMappingURL=stylistic.js.map